package sim_calc;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Hashtable;

public class MatriceGeni {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		//carico hashtable mapping geni-id//
		Hashtable<String, Integer> map_geni = new Hashtable<String, Integer>();
		ObjectInputStream ois;
		System.out.println("start load map_geni...");
		try{
			ois = new ObjectInputStream(new FileInputStream("map_geni"));
			map_geni = (Hashtable<String, Integer>) ois.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading map_geni");
			e.printStackTrace();
		}
		System.out.println("done!");
		//----------------------------------//
		
		//carico file simil sequ ridotto//
		ArrayList<Tupla_gene> SIM_SEQU = new ArrayList<Tupla_gene>();
		ObjectInputStream ois1;
		System.out.println("start load SIM_SEQU...");
		try{
			ois1 = new ObjectInputStream(new FileInputStream("SIM_SEQU"));
			SIM_SEQU = (ArrayList<Tupla_gene>) ois1.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading SIM_SEQU");
			e.printStackTrace();
		}
		System.out.println("done!");
		//--------------------------------//
		
		Hashtable<String, Double> sim_sequenza = new Hashtable<String, Double>();
		for(Tupla_gene tg : SIM_SEQU){
			String ge1_ge2 = tg.id_1+"-"+tg.id_2;
			sim_sequenza.put(ge1_ge2, tg.sim);
		}
		int tes=0;
		ArrayList<Tupla_gene> finale = new ArrayList<Tupla_gene>();
		System.out.println("Calcolando...");
		for(String g:sim_sequenza.keySet()){
			double sim_fin=sim_sequenza.get(g);
			for(String g2: sim_sequenza.keySet()){
				if(g2.compareTo(g)==0){
					if(sim_sequenza.get(g2)>sim_sequenza.get(g)){
						sim_fin=sim_sequenza.get(g2);
					}
				}
			}
			Tupla_gene tu = new Tupla_gene();
			String[] sp = g.split("-");
			tu.id_1 = sp[0];
			tu.id_2 = sp[1];
			tu.sim = sim_fin;
			finale.add(tu);
			if(tes<10){
				System.out.println("similarit sequenza: ");
				System.out.println("id_1 = "+tu.id_1);
				System.out.println("id_2 = "+tu.id_2);
				System.out.println("sim = "+tu.sim);
			}
			tes++;
		}
		System.out.println("fine!");
			
		StoreFile("Sim_seq_fin", finale);
		
	}
	
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
			ObjectOutputStream oss;
	        try{
	            oss = new ObjectOutputStream(new FileOutputStream(FileName));
	            oss.writeObject(structure);
	            oss.close();
	        }
	        catch(Exception e1){
	                System.out.println("error during store "+FileName);
	                e1.printStackTrace();
	        }
	        System.out.println("Done!");
		}

}
