package sim_calc;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import annotation.Annotation_record_reduced;
import annotation.Annotations_record;

public class ReadGene {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Hashtable<String, Integer> map_geni = new Hashtable<String, Integer>();
		ArrayList<Tupla_gene> file_ridotto = new ArrayList<Tupla_gene>();
		Hashtable<String, Double> finale = new Hashtable<String, Double>();
		int indice=0;
		String romano="";
		
		int pp=0;
		for(int i=0;i<16;i++){
			if(i==0)romano="I.table";
			else if(i==1)romano="II.table";
			else if(i==2)romano="III.table";
			else if(i==3)romano="IV.table";
			else if(i==4)romano="V.table";
			else if(i==5)romano="VI.table";
			else if(i==6)romano="VII.table";
			else if(i==7)romano="VIII.table";
			else if(i==8)romano="IX.table";
			else if(i==9)romano="X.table";
			else if(i==10)romano="XI.table";
			else if(i==11)romano="XII.table";
			else if(i==12)romano="XIII.table";
			else if(i==13)romano="XIV.table";
			else if(i==14)romano="XV.table";
			else if(i==15)romano="XVI.table";
			
			try
	        {
	            FileReader fr = new FileReader("test/protein/chr"+romano);
	            BufferedReader in = new BufferedReader(fr);
	            String line;
	            System.out.println("Start parsing chr"+romano+"...");
	            while ((line = in.readLine()) != null){
	            	
	            	/* per ogni linea(riga) letta dal file,
	            	 * viene creato un oggetto di tipo 
	            	 * tupla_gene,
	            	 * quest'ultimo viene inserito nella
	            	 * hashtable geni_dist
	            	 */
	            	Tupla_gene tupla = new Tupla_gene();
	            	String[] output;
	            	output =  line.split("\t");
	            	if(output[3].compareTo("")==0)continue;
	            	String conc = output[0]+";"+output[3];
	            	if(pp<10){
	            		System.out.println(conc);
	            		String[] prov = conc.split(";");
	            		System.out.println("size = "+prov.length);
	            		System.out.println(prov[0]);
	            		System.out.println(prov[1]);
	            	}
	            	if(finale.containsKey(conc)){
	            		if(finale.get(conc)<Double.parseDouble(output[7])){
	            			finale.remove(conc);
	            			finale.put(conc, Double.parseDouble(output[7]));
	            		}
	            	}
	            	else finale.put(conc, Double.parseDouble(output[7]));
	            	
	            	tupla.id_1=output[0];
	            	tupla.id_2=output[3];
	            	tupla.sim=Double.parseDouble(output[7])
	            			;
	            	//controllo se nel file di hash ci sono i due geni presenti nel record che sto analizzando,
	            	//se uno di questi non c' lo aggiungo alla lista dei geni distinti
	            	if(!map_geni.containsKey(output[0])){
	            		map_geni.put(output[0], indice);
	            		indice++;
	            	}
	            	if(!map_geni.containsKey(output[3])){
	            		map_geni.put(output[3], indice);
	            		indice++;
	            	}
	            	file_ridotto.add(tupla);
	            	if(pp<10){
	            		System.out.println("tupla "+pp+":");
	            		System.out.println("id_1 = "+tupla.id_1);
	            		System.out.println("id_2 = "+tupla.id_2);
	            		System.out.println("sim = "+tupla.sim);
	            	}
	            	pp++;
	            		
	            }
	            System.out.println("END.");
	        }
	    	catch(IOException e){ }
			
		}//chiude for tutti i file
		StoreFile("SIM_SEQU", file_ridotto);
        StoreFile("map_geni", map_geni);
        StoreFile("finale", finale);
		

	}
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
			ObjectOutputStream oss;
	        try{
	            oss = new ObjectOutputStream(new FileOutputStream(FileName));
	            oss.writeObject(structure);
	            oss.close();
	        }
	        catch(Exception e1){
	                System.out.println("error during store "+FileName);
	                e1.printStackTrace();
	        }
	        System.out.println("Done!");
		}

}
