package obo;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Hashtable;

public class Get_RandomWalk{
	
	public void get_rw(String Path_version,String Path,String Aspect,String meaure_host){
		System.out.println("Calcolo RandomWalk...");
		
		ArrayList<String> terms_for_LCA = new ArrayList<String>();
		ObjectInputStream ois11;
		System.out.println("start load terms_for_LCA...");
		try{
			ois11 = new ObjectInputStream(new FileInputStream(Path+"/terms_for_LCA"));
			terms_for_LCA = (ArrayList<String>) ois11.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading terms_for_LCA");
			e.printStackTrace();
		}
		System.out.println("done!");
		
		//carico UpXX
		Hashtable<String, ArrayList<String>> UpTT = new Hashtable<String, ArrayList<String>>();
		if(Aspect.compareTo("C")==0){
			ObjectInputStream ois7;
			System.out.println("start load UpCC...");
			try{
				ois7 = new ObjectInputStream(new FileInputStream(Path_version+"/UpCC"));
				UpTT = (Hashtable<String, ArrayList<String>>) ois7.readObject();
			}
			catch(Exception e){
				System.out.println("error during loading UpCC");
				e.printStackTrace();
			}
			System.out.println("done!");
		}
		else if(Aspect.compareTo("P")==0){
			ObjectInputStream ois7;
			System.out.println("start load UpBP...");
			try{
				ois7 = new ObjectInputStream(new FileInputStream(Path_version+"/UpBP"));
				UpTT = (Hashtable<String, ArrayList<String>>) ois7.readObject();
			}
			catch(Exception e){
				System.out.println("error during loading UpBP");
				e.printStackTrace();
			}
			System.out.println("done!");
		}
		else if(Aspect.compareTo("F")==0){
			ObjectInputStream ois7;
			System.out.println("start load UpMF...");
			try{
				ois7 = new ObjectInputStream(new FileInputStream(Path_version+"/UpMF"));
				UpTT = (Hashtable<String, ArrayList<String>>) ois7.readObject();
			}
			catch(Exception e){
				System.out.println("error during loading UpMF");
				e.printStackTrace();
			}
			System.out.println("done!");
		}
		
		//carico GO_GENE (TREE_P)
		Hashtable<String, Double> GO_GENE = new Hashtable<String, Double>();
		ObjectInputStream ois9;
		System.out.println("start load GO_GENE...");
		try{
			ois9 = new ObjectInputStream(new FileInputStream(Path+"/GO_GENE"));
			GO_GENE = (Hashtable<String, Double>) ois9.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading GO_GENE");
			e.printStackTrace();
		}
		System.out.println("done!");
		//-------------------------
		
		//carico mapping_ID_indici
		Hashtable<String,Integer> mapping_ID_Indici = new Hashtable<String, Integer>();
		ObjectInputStream ois19;
		System.out.println("start load mapping_ID_indici...");
		try{
			ois19 = new ObjectInputStream(new FileInputStream(Path+"/mapping_ID_Indici"));
			mapping_ID_Indici = (Hashtable<String, Integer>) ois19.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading mapping_ID_Indici");
			e.printStackTrace();
		}
		System.out.println("done!");
		//---------------------------
		
		//carico mapping_Indici_ID
		Hashtable<Integer,String> mapping_Indici_ID = new Hashtable<Integer,String>();
		ObjectInputStream ois18;
		System.out.println("start load mapping_Indici_ID...");
		try{
			ois18 = new ObjectInputStream(new FileInputStream(Path+"/mapping_Indici_ID"));
			mapping_Indici_ID = (Hashtable<Integer, String>) ois18.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading mapping_Indici_ID");
			e.printStackTrace();
		}
		System.out.println("done!");
		//-----------------------------
		
		//carico misura HOST
		double[][] HOST = new double[terms_for_LCA.size()][terms_for_LCA.size()];
		ObjectInputStream ois13;
		System.out.println("start load Misure_HOST"+meaure_host+"...");
		try{
			ois13 = new ObjectInputStream(new FileInputStream(Path+"/"+meaure_host));
			HOST = (double[][]) ois13.readObject();
		}
		catch(Exception e){
			System.out.println("error during loading "+meaure_host);
			e.printStackTrace();
		}
		System.out.println("done!");
		//------------------
		
		/* creo la matrice TREE e la inizializzo a zero */
		int[][] TREE;
		TREE = new int[terms_for_LCA.size()][terms_for_LCA.size()];
		int rig,col;
		for (rig=0;rig<TREE.length;rig++){//scorre righe
			for(col=0;col<TREE[0].length;col++){//scorre colonne della riga
				TREE[rig][col]=0;
			}
		}
		
		GetDistri_result gt = new GetDistri_result();
	    gt = getDistri(UpTT,GO_GENE,1,mapping_ID_Indici,mapping_Indici_ID,TREE);
	    System.out.println("GetDistri: dim DISTRI = "+gt.DISTRI.length+"x"+gt.DISTRI[0].length);
	    
	  //MODEL=zeros(size(HOST));
	    System.out.println("costruisco MODEL e la inizializzo a 0...");
	    double[][] MODEL = new double[HOST.length][HOST[0].length];
	    for(int qw=0;qw<MODEL.length;qw++){//scorro righe
	        for(int ws=0;ws<MODEL[0].length;ws++){//scorro colonne
	        	MODEL[qw][ws]=0.0;
	        }
	    }
	    System.out.println("fatto!");
	        
	    //costruisco HOST_Le=HOST(Le1,Le1);   
	    System.out.println("Costruisco HOST_Le...");
	    int[] Host_Le_Index = new int[gt.True_le.length];//Host_Le_Index conterra gli indici in Resnik degli elementi in gt.True_le
	    for(int yy=0;yy<gt.True_le.length;yy++){
	        String nome= gt.mapping_indici_ID.get(gt.True_le[yy]);
	        int indice= mapping_ID_Indici.get(nome);
	        Host_Le_Index[yy] = indice;
	    }
	    double[][] Host_Le = new double[Host_Le_Index.length][Host_Le_Index.length];
	    for(int mm=0;mm<Host_Le.length;mm++){
	        for(int nn=0;nn<Host_Le[0].length;nn++){
	        	Host_Le[mm][nn] = HOST[Host_Le_Index[mm]][Host_Le_Index[nn]];
	        }
	    }
	    System.out.println("fatto!");
	    
	    double[][] DISTRI_t = trasposta(gt.DISTRI);
	    
	    double[][] TEMP_1 = prodMatriciNonQuadrate(DISTRI_t, Host_Le);
	    double[][] t=prodMatriciNonQuadrate(TEMP_1, gt.DISTRI);
	    
	  //MODEL(Le_plus_Br,Le_plus_Br)=t
	    for(int pp=0;pp<MODEL.length;pp++){//scorre righe
	        for(int ii=0;ii<MODEL[0].length;ii++){//scorre colonne
	        	MODEL[pp][ii] = t[pp][ii];
	        }
	    }
	    
	    /*RWResnik = MODEL+RESNIK; RWJiang = MODEL+JIANG; RWLin = MODEL+LIN; */
	    double[][] RW = new double[HOST.length][HOST.length];
	    
	    for(int rr=0;rr<HOST.length;rr++){//scorro righe resnik
	        String term1 = mapping_Indici_ID.get(rr);//prendo il termine che in Resnik corrisponde all'indice rr
	        int ind_in_MODEL = -1;
	        for(int mm=0;mm<gt.Le_plus_Br.length;mm++){//scorro gli indici in Le-plus-Br che sono quelli usati da MODEL
	        	if(gt.Le_plus_Br[mm]==mapping_ID_Indici.get(term1))ind_in_MODEL=mm;//prendo l'indice del termini term1 in MODEL e lo assegno a ind_in_model
	        }
	        for(int cc=0;cc<HOST[0].length;cc++){//scorro colonne resnik
	        	String term2 = mapping_Indici_ID.get(cc);//prendo il termine che in Resnik corrisponde all'indice rr
		        int ind_in_MODEL2 = -1;
		        for(int nn=0;nn<gt.Le_plus_Br.length;nn++){//scorro gli indici in Le-plus-Br che sono quelli usati da MODEL
		        	if(gt.Le_plus_Br[nn]==mapping_ID_Indici.get(term2))ind_in_MODEL2=nn;//prendo l'indice del termini term1 in MODEL e lo assegno a ind_in_model
		        }
		        RW[rr][cc] = HOST[rr][cc] + MODEL[ind_in_MODEL][ind_in_MODEL2];
		    }
	    }
	    
	  //TEST
	   /* System.out.println("RW"+meaure_host+"["+mapping_ID_Indici.get("GO:0000015")+"]["+mapping_ID_Indici.get("GO:0000015")+"] = "+RW[mapping_ID_Indici.get("GO:0000015")][mapping_ID_Indici.get("GO:0000015")]);
	    System.out.println("RW"+meaure_host+"["+mapping_ID_Indici.get("GO:0000015")+"]["+mapping_ID_Indici.get("GO:0000108")+"] = "+RW[mapping_ID_Indici.get("GO:0000015")][mapping_ID_Indici.get("GO:0000108")]);
	    System.out.println("RW"+meaure_host+"["+mapping_ID_Indici.get("GO:0000015")+"]["+mapping_ID_Indici.get("GO:0000109")+"] = "+RW[mapping_ID_Indici.get("GO:0000015")][mapping_ID_Indici.get("GO:0000109")]);
	    System.out.println("RW"+meaure_host+"["+mapping_ID_Indici.get("GO:0000123")+"]["+mapping_ID_Indici.get("GO:0000118")+"] = "+RW[mapping_ID_Indici.get("GO:0000123")][mapping_ID_Indici.get("GO:0000118")]);
	    System.out.println("RW"+meaure_host+"["+mapping_ID_Indici.get("GO:0000131")+"]["+mapping_ID_Indici.get("GO:0000110")+"] = "+RW[mapping_ID_Indici.get("GO:0000131")][mapping_ID_Indici.get("GO:0000110")]);
	    System.out.println("Fine calcolo RandomWalk");
	  */  
	    StoreFile(Path+"/RW"+meaure_host, RW);
	    
	}
	
	public static double[][] trasposta(double[][] A){
		double[][] ris = new double[A[0].length][A.length];
		for(int uu=0;uu<A.length;uu++){//scorro righe di A 
			for(int aa=0;aa<A[0].length;aa++){//scorro colonne di A
				ris[aa][uu] = A[uu][aa];//la cella a,u di ris sar uguale alla cella u,a di A.
			}
		}
		return ris;
	}
	
	public static double[][] prodMatriciNonQuadrate(double[][] A,double[][] B){
		double[][] ris = new double[A.length][B[0].length];//righe di A e colonne di B
		for(int i=0;i<A.length;i++){//scorro righe di A 
			for(int j=0;j<B[0].length;j++){//scorro colonne di B
				ris[i][j]=0;
                for (int k=0; k<B.length; k++)//scorre di righe di B(o colonne di A             
                    ris[i][j] += A[i][k] * B[k][j]; 
			}
		}
		return ris;
	}
	
	public static GetDistri_result getDistri(Hashtable<String, ArrayList<String>> UpTT,Hashtable<String, Double> GO_GENE,int leak,Hashtable<String, Integer>mapping_ID_Indici,Hashtable<Integer, String> mapping_Indici_ID,int[][] TREE){
       
		//Updegree conterr per ogni termine in TREE, il numero di 1ni nella sua riga
		Hashtable<String, Integer> Updegree = new Hashtable<String, Integer>();

		for(String trm: mapping_ID_Indici.keySet()){
			int count_updeg = 0;
			int indice_termine = mapping_ID_Indici.get(trm);
			for(String top: mapping_ID_Indici.keySet()){
				if(UpTT.get(trm).contains(top)){//trovato termine padre
					int indice_padre = mapping_ID_Indici.get(top);
					TREE[indice_termine][indice_padre]=1;
					count_updeg++;
				}
			}
			Updegree.put(trm, count_updeg);
		}
		
       //creo T1 e T2 (vedi GetDistri.m)
       /* creo la matrice T1 e la inizializzo a zero */
       System.out.println("Inizializzo T1 e T2...");
		double[][] T1;
		T1 = new double[TREE.length][TREE[0].length];
		int rig1,col1;
		for (rig1=0;rig1<TREE.length;rig1++){//scorre righe
			for(col1=0;col1<TREE[0].length;col1++){//scorre colonne della riga
				T1[rig1][col1]=0;
			}
		}
		System.out.println("T1 size = ["+T1.length+"]["+T1[0].length+"]");
		 /* creo la matrice T2 e la inizializzo a zero */
		double[][] T2;
		T2 = new double[TREE.length][TREE[0].length];
		int rig2,col2;
		for (rig2=0;rig2<TREE.length;rig2++){//scorre righe
			for(col2=0;col2<TREE[0].length;col2++){//scorre colonne della riga
				T2[rig2][col2]=0;
			}
		}
		System.out.println("T2 size = ["+T2.length+"]["+T2[0].length+"]");
		
		//costruisco Tree_p relativo solo ai termini in TREE,il nostro Tree_p  GO_GENE
		Hashtable<String, Double> TREE_P = new Hashtable<String, Double>();
		for(String kl: GO_GENE.keySet()){
			if(mapping_ID_Indici.keySet().contains(kl)){
				TREE_P.put(kl, GO_GENE.get(kl));
			}
		}
		
		System.out.println("compiling T1...");
		//compilo T1
		for(String te:TREE_P.keySet()){
			int ind_te = mapping_ID_Indici.get(te);
			if(Updegree.get(te)>0){
				for(int l=0;l<TREE.length;l++){
					T1[ind_te][l] = ( TREE_P.get(te)*TREE[ind_te][l] )/ Updegree.get(te);
				}
			}
		}
		System.out.println("fatto!");
		
		//SumTree_p contiene la somma di ogni colonna di T1
		System.out.println("Calcolo SumTree_p...");
		double[] SumTree_p;
		SumTree_p = new double [TREE.length];
		for(int colonna=0;colonna<TREE.length;colonna++){
			SumTree_p[colonna] = sommaColonna(colonna,T1);
		}
		System.out.println("fatto!");
		
		//True_Le contiene gli indici di T1 che hanno Tree_p > 0 e SumTree_p==0, ossia i termini foglia
		System.out.println("calcolo True_le...");
		int count_senza_figli = 0;
		for(int y=0;y<SumTree_p.length;y++){
			if(SumTree_p[y]==0 && TREE_P.get(mapping_Indici_ID.get(y))>0 )count_senza_figli++;
		}
		int[] True_Le;
		True_Le = new int[count_senza_figli];
		int a=0;
		for(int p=0;p<SumTree_p.length;p++){
			if(SumTree_p[p]==0){
				True_Le[a]=p;//memorizzo l'indice del termine in SumTree_p
				a++;
			}
		}
		System.out.println("fatto!");
		
		//Le_plus_Br contiene i termini foglia e i termini non foglia(i loro indici in T1) che hanno Tree_p>0,ossiam hanno almeno un gene annotato.
		System.out.println("calcolo Le_plus_Br...");
		int count_Tree_p_maggiore_zero = 0;
		for(String gh:TREE_P.keySet()){
			if(TREE_P.get(gh)>0)count_Tree_p_maggiore_zero++;
		}
		int[] Le_plus_Br;
		Le_plus_Br = new int[count_Tree_p_maggiore_zero];
		int b=0;
		for(String rh:TREE_P.keySet()){
			if(TREE_P.get(rh)>0){
				int ind = mapping_ID_Indici.get(rh);
				Le_plus_Br[b]=ind;
				b++;
			}
		}
		System.out.println("fatto!");
		
		//Br contiene i termini(i loro indici in T1) che hanno almeno un figlio, ossiam i termini che in con SumTree_p>0.
		System.out.println("calcolo Br...");
		int count_sum_mag_zero=0;
       for(int n=0;n<SumTree_p.length;n++){
       	if(SumTree_p[n]>0.0)count_sum_mag_zero++;
       }
       int[] Br;
       Br = new int[count_sum_mag_zero];
       int c=0;
       for(int x=0;x<SumTree_p.length;x++){
       	if(SumTree_p[x]>0.0){
       		Br[c]=x;//memorizzo l'indice del termine in SumTree_p
       		c++;
       	}
       }
       System.out.println("fatto!");
       
       /* compilo T2, che contiene in corrispondenza delle colonne che rappresentano gli elementi 
        * in Br, il valore dato da: 1*T1(:,Br)*diag(1./Tree_p(Br)).
        * dove T1(:,Br)  il valore di tali elementi in T1, mentre diag(1./Tree_p(Br))  una matrice
        * di dimensione cardinalit Br x cardinalit Br che ha sulla diagonale i valori 1/Tree_p(Br).
        */
       
       if(leak==1){
       	//calcolo diag(1./Tree_p(Br))
       	System.out.println("calcolo diag(1./Tree_p(Br)...");
       	double[][] diag;
       	diag = new double[Br.length][Br.length];
       	for(int d=0;d<Br.length;d++){
       		//prendo Tree_p(d)
       		String ter_ = mapping_Indici_ID.get(Br[d]);
       		double Tree_p_ter_ = TREE_P.get(ter_);
       		diag[d][d]=(1/Tree_p_ter_);
       	}	//lo inserisco sulla diag
       	System.out.println("fatto!");
       	
       	//calcolo leak*T1[:][Br] e li metto nella matrice intermedia X
       	System.out.println("calcolo matrice X = 1*T1(:,Br)");
       	double[][] X;
       	X = new double[T1.length][Br.length];
       	for(int q=0;q<Br.length;q++){//scorre colonne pari al numero degli indici in Br
       		for(int r=0;r<T1.length;r++){//scorre righe di T1
       			X[r][q] = 1*T1[r][Br[q]]; 
       		}
       	}
       	System.out.println("fatto!");
       	
       	//calcolo T2(:,Br) = leak*T1(:,Br)*diag(1./Tree_p(Br))
       	//calcolo prodotto tra matrice X e diag
       	System.out.println("calcolo matrice X2 = 1*T1(:,Br)*diag(1./Tree_p(Br))");
	    double[][] X2;
	    X2 = prodottoMatrici(X,diag);
	    System.out.println("fatto!");
	    
	    //compilo T2
	    System.out.println("compilo T2...");
	    for(int rew=0;rew<T2.length;rew++){//scorre righe
	        for(int rix=0;rix<Br.length;rix++){//scorre colonne pari al numero di indici in Br
	        	T2[rew][Br[rix]]=X2[rew][rix];
	        }
	    }
	    System.out.println("fatto!");
	    
       }
       else{
       	//calcolo diag(1./SumTree_p(Br))
       	System.out.println("calcolo diag(1./SumTree_p(Br)...");
       	double[][] diag;
       	diag = new double[Br.length][Br.length];
       	for(int d=0;d<Br.length;d++){
       		//prendo Tree_p(d)
       		String ter_ = mapping_Indici_ID.get(Br[d]);
       		double Tree_p_ter_ = TREE_P.get(ter_);
       		diag[d][d]=(1/Tree_p_ter_);
       	}	//lo inserisco sulla diag
       	
       	System.out.println("calcolo matrice X2 = T1(:,Br)*diag(1./SumTree_p(Br))");
	        double[][] X2;
	        X2 = prodottoMatrici(T1,diag);
	        System.out.println("fatto!");
	        
	        System.out.println("compilo T2...");
	        for(int rew=0;rew<T2.length;rew++){//scorre righe
	        	for(int rix=0;rix<Br.length;rix++){//scorre colonne pari al numero di indici in Br
	        		T2[rew][Br[rix]]=X2[rew][rix];
	        	}
	        }
	        System.out.println("fatto!");
       }
       
       //T3(True_le,True_Le) = eye(length(True_le)); 
       System.out.println("calcolo T3...");
       double[][] T3 = T2;
       for(int ind_True_le=0;ind_True_le<True_Le.length;ind_True_le++){
       	int ind_in_T3 = True_Le[ind_True_le];
       	T3[ind_in_T3][ind_in_T3]=1;
       }
       System.out.println("fatto!");
       
       //costruisco Br_Br=T3(Br,Br);
       System.out.println("costruisco Br_Br...");
       double[][] Br_Br = new double[Br.length][Br.length];
       for(int er=0;er<Br.length;er++){
       	int ind_T3 = Br[er];
       	for(int re=0;re<Br.length;re++){
       		int ind_re = Br[re];
       		Br_Br[er][re]=T3[ind_T3][ind_re];
       	}
       }
       System.out.println("fatto!");
       
     //costruisco Le_Br=T3(True_Le,Br);
       System.out.println("costruisco Le_Br...");
       double[][] Le_Br = new double[True_Le.length][Br.length];
       for(int iu=0;iu<True_Le.length;iu++){
       	int ind_Tr = True_Le[iu];
       	for(int lo=0;lo<Br.length;lo++){
       		int ind_lo = Br[lo];
       		Le_Br[iu][lo]=T3[ind_Tr][ind_lo];
       	}
       }
       System.out.println("fatto!");
       
       //costruisco Br2Le=zeros(length(True_Le),length(Br));
       System.out.println("costruisco Br2Le...");
       double[][] Br2Le = new double[True_Le.length][Br.length];
       for(int cd=0;cd<Br2Le.length;cd++){//scorre righe
       	for(int rt=0;rt<Br2Le[0].length;rt++){//scorre colonne
       		Br2Le[cd][rt]=0.0;
       	}
       }
       System.out.println("fatto!");
       System.out.println("num righe Br2Le = "+Br2Le.length);
       System.out.println("num colonne Br2Le = "+Br2Le[0].length);
       
       //costruisco BR=eye(length(Br));
       System.out.println("costruisco BR...");
       double[][] BR = new double [Br.length][Br.length];
       for(int nb=0;nb<BR.length;nb++){//scorre righe
       	for(int mn=0;mn<BR[0].length;mn++){//scorre colonne
       		if(mn==nb)BR[nb][mn]=1;
       		else BR[nb][mn]=0.0;
       	}
       }
       System.out.println("fatto!");
       
       //calcolo con=sum(sum(BR));
       System.out.println("calcolo con...");
       double con=0.0;
       for(int kl=0;kl<BR.length;kl++){//scorre righe
       	for(int nh=0;nh<BR[0].length;nh++){//scorre colonne
       		con+=BR[kl][nh];
       	}
       }
       System.out.println("fatto!");
       //Test con
       System.out.println("somma con = "+con);
       //--Fine Test
       
       /* compilo Br2Le, BR, e calcolo nuovo con--> 
        * while(con>0.001){
        * 		Br2Le=Br2Le+Le_Br*BR;
				BR=Br_Br*BR;    
				con=sum(sum(BR))
        	}
        */
       System.out.println("calcolo nuovi con...");
       int count=0;
       while(con>0.001){
       	count++;
       	double sum=0.0;
       	Br2Le = sommaMatrice(Br2Le, prodottoMatrici(Le_Br, BR));
       	BR = prodottoMatrici(Br_Br, BR);
       	for(int kl=0;kl<BR.length;kl++){//scorre righe
	        	for(int nh=0;nh<BR[0].length;nh++){//scorre colonne
	        		sum+=BR[kl][nh];
	        	}
	        }
       	con=sum;
       	System.out.println("con_"+count+" = "+con);
       }
       System.out.println("fatto!");
       
       //inizializzo DISTRI=zeros(length(True_Le), length(Le_plus_Br));
       System.out.println("Inizializzo DISTRI...");
       double[][] DISTRI = new double[True_Le.length][Le_plus_Br.length];
       for(int bv=0;bv<True_Le.length;bv++){//scorro righe
       	for(int ki=0;ki<Le_plus_Br.length;ki++){//scorro colonne
       		DISTRI[bv][ki]=0.0;
       	}
       }
       System.out.println("fatto!");
       System.out.println("dimensione DISTRI = "+DISTRI.length+"x"+DISTRI[0].length);
       
       //Br_Ind=ismember(Br,Le_plus_Br)
       System.out.println("Prendo indici degli elementi in Br in Le_plus_Br...");
       int count_in=0;
       for(int lp=0;lp<Br.length;lp++){
       	int in = Br[lp];
       	for(int ij=0;ij<Le_plus_Br.length;ij++){
       		if(Le_plus_Br[ij]==in)count_in++;
       	}
       }
       System.out.println("elementi di Br in Le_plus_Br = "+count_in);
       int[] Br_Ind = new int[count_in];
       int cc=0;
       for(int lp=0;lp<Br.length;lp++){
       	int in = Br[lp];
       	for(int ij=0;ij<Le_plus_Br.length;ij++){
       		if(Le_plus_Br[ij]==in){
       			Br_Ind[cc]=ij;
       			cc++;
       		}
       	}
       }
       System.out.println("fatto!");
       
       //Le_ind=ismember(True_Le,Le_plus_Br);
       System.out.println("Prendo indici degli elementi in True_le in Le_plus_Br...");
       int count_in2=0;
       for(int lp=0;lp<True_Le.length;lp++){
       	int in = True_Le[lp];
       	for(int ij=0;ij<Le_plus_Br.length;ij++){
       		if(Le_plus_Br[ij]==in)count_in2++;
       	}
       }
       System.out.println("elementi di True_Le in Le_plus_Br = "+count_in2);
       int[] Le_Ind = new int[count_in2];
       int cc2=0;
       for(int lp=0;lp<True_Le.length;lp++){
       	int in = True_Le[lp];
       	for(int ij=0;ij<Le_plus_Br.length;ij++){
       		if(Le_plus_Br[ij]==in){
       			Le_Ind[cc2]=ij;
       			cc2++;
       		}
       	}
       }
       System.out.println("fatto!");
       
       //compilo DISTRI(:,Br_ind)=Br2Le; 
       System.out.println("compilo DISTRI con Br_ind...");
       for(int we=0;we<DISTRI.length;we++){//scorre righe
       	for(int qa=0;qa<Br_Ind.length;qa++){//scorro indici in Br_Ind
       		DISTRI[we][Br_Ind[qa]]=Br2Le[we][qa];
       	}
       }
       System.out.println("fatto!");
       
       //compilo DISTRI(:, Le_ind)=eye(length(True_Le));
       System.out.println("compilo DISTRI con eye(Le_ind)...");
       for(int tue=0;tue<DISTRI.length;tue++){//scorre righe
       	for(int za=0;za<Le_Ind.length;za++){//scorro indici colonne corrispondenti a True_le
       		DISTRI[tue][Le_Ind[tue]]=1;
       	}
       }
       System.out.println("fatto!");
       
		GetDistri_result result = new GetDistri_result();
		result.DISTRI=DISTRI;
		result.Le_plus_Br=Le_plus_Br;
		result.True_le=True_Le;
		result.mapping_ID_indici=mapping_ID_Indici;
		result.mapping_indici_ID=mapping_Indici_ID;
		System.out.println("Fine GetDistri!");
		return result;
	}
	
	public static double[][] sommaMatrice(double[][] a,double[][] b){
		
		double[][] ris=new double[a.length][a[0].length];
		for (int i=0;i<ris.length;i++){//scorre righe
			for (int j=0;j<ris[i].length;j++){//scorre colonne
				ris[i][j]=a[i][j]+b[i][j];
			}
		}
		return ris;
	}
	
	
	public static double[][] prodottoMatrici(double[][] A, double[][] B) {
        double[][] C = new double [A.length][B.length];
        for (int i=0; i<A.length; i++) //scorre righe di A
            for (int j=0; j<B.length; j++) {//scorre righe di B
                C[i][j]=0;
                for (int k=0; k<B.length; k++)//scorre di nuovo righe di B             
                    C[i][j] += A[i][k] * B[k][j]; 
            }
        return C;
    }
	
	public static double sommaColonna(int column,double[][] T1) { //la prima colonna = 0
	  double somma = 0.0;
	  for (int row = 0; row < T1.length; row++) {
	    somma += T1[row][column];
	  }
	  //System.out.println("Somma colonna n." + column + " = " +somma);
	  return somma;
	}
	
	public static void StoreFile(String FileName, Object structure){
		System.out.println("Storing "+FileName+"...");
			ObjectOutputStream oss;
	        try{
	            oss = new ObjectOutputStream(new FileOutputStream(FileName));
	            oss.writeObject(structure);
	            oss.close();
	        }
	        catch(Exception e1){
	                System.out.println("error during store "+FileName);
	                e1.printStackTrace();
	        }
	        System.out.println("Done!");
		}

}
