package sim_calc;

import org.jfree.chart.renderer.category.BarRenderer;
import java.awt.Color;
import java.awt.Paint;

class CustomRenderer extends BarRenderer
{
 private Paint[] colors;

 public CustomRenderer()
 {
    this.colors = new Paint[] {Color.red,Color.blue};
 }

 public Paint getItemPaint(final int row, final int column)
 {
    // returns color for each column
    return (this.colors[column % this.colors.length]);
 }
}
