package sim_calc;

import java.awt.Color;
import java.awt.Shape;
import java.text.AttributedString;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartFrame;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.LegendItem;
import org.jfree.chart.LegendItemCollection;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.chart.renderer.category.CategoryItemRenderer;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.general.DefaultPieDataset;

import com.lowagie.text.Rectangle;


public class First {
	public static void main(String[] args) {
		
		
			
			// create a dataset...
			DefaultCategoryDataset dataset = new DefaultCategoryDataset();
			
			// row keys...
			
			String series1 = "Resnk";
			String series2 = "RW+Resnik";
			String series3 = "Lin";
			String series4 = "RW+Lin";
			String series5 = "Jiang";
			String series6 = "RW+Jiang";

			// column keys...
			String category1 = "BP";
			String category2 = "CC";
			String category3 = "MF";

			dataset.addValue(0.605, series1, category1);//bp
			dataset.addValue(0.64, series2, category1);
			dataset.addValue(0.61, series3, category1);
			dataset.addValue(0.63, series4, category1);
			dataset.addValue(0.58, series5, category1);
			dataset.addValue(0.62, series6, category1);
			
			dataset.addValue(0.70, series1, category2);//cc
			dataset.addValue(0.73, series2, category2);
			dataset.addValue(0.68, series3, category2);
			dataset.addValue(0.71, series4, category2);
			dataset.addValue(0.66, series5, category2);
			dataset.addValue(0.70, series6, category2);
			
			dataset.addValue(0.53, series1, category3);//mf
			dataset.addValue(0.45, series2, category3);
			dataset.addValue(0.61, series3, category3);
			dataset.addValue(0.59, series4, category3);
			dataset.addValue(0.62, series5, category3);
			dataset.addValue(0.56, series6, category3);
			
			JFreeChart chart = ChartFactory.createBarChart("Correlazione tra similarit semantica e similarit di sequenza (file 2011)", // chart
					// title
					"Dominio", // domain axis label
					"Coefficiente di correlazione di Pearson", // range axis label
					dataset, // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);
			
			CategoryPlot plot = (CategoryPlot) chart.getPlot();
			/*
			CategoryItemRenderer renderer = new CustomRenderer();
			plot.setRenderer(renderer);
			BarRenderer br = (BarRenderer) plot.getRenderer();
			br.setMaximumBarWidth(.10); // set maximum width to 35% of chart
			*/
			plot.setBackgroundPaint(Color.white);
			plot.setDomainGridlinePaint(Color.white);//linne corrispondenti ai valori sulle ascisse
			plot.setDomainGridlinesVisible(true);
			plot.setRangeGridlinePaint(Color.white);//linee corrispondenti ai valori sulle ordinate
		
			

			
			// create and display a frame...
			ChartFrame frame = new ChartFrame("Risultati", chart);
			frame.pack();
			frame.setVisible(true);
			
		}
		
		
}